"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.Interval = void 0;

const vgrammar_util_1 = require("@visactor/vgrammar-util"), semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), vutils_1 = require("@visactor/vutils"), enums_1 = require("./enums");

class Interval extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.interval, id);
    }
    setMarkType() {
        var _a;
        return "polar" === (null === (_a = this._coordinate) || void 0 === _a ? void 0 : _a.type) ? vgrammar_core_1.GrammarMarkType.arc : vgrammar_core_1.GrammarMarkType.rect;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    setDefaultMarkTransform() {
        var _a, _b, _c, _d;
        return [ {
            type: "dodge",
            minWidth: null === (_a = this.spec.style) || void 0 === _a ? void 0 : _a.minWidth,
            maxWidth: null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.maxWidth,
            innerGap: null === (_c = this.spec.style) || void 0 === _c ? void 0 : _c.innerGap,
            categoryGap: null === (_d = this.spec.style) || void 0 === _d ? void 0 : _d.categoryGap
        } ];
    }
    setDefaultCrosshair() {
        return {
            x: {
                crosshairShape: "rect"
            }
        };
    }
    setDefaultTooltip() {
        var _a;
        const encodeY = null === (_a = this.spec.encode) || void 0 === _a ? void 0 : _a.y;
        return {
            content: (0, vutils_1.isArray)(encodeY) ? encodeY.map((entry => ({
                value: entry
            }))) : [ {
                value: encodeY
            } ]
        };
    }
    setMainMarkSpec() {
        var _a;
        return "polar" === (null === (_a = this._coordinate) || void 0 === _a ? void 0 : _a.type) ? {
            attributeTransforms: [ {
                channels: [ "x", "y", "x1", "y1", "cx", "cy" ],
                transform: (graphicAttributes, nextAttrs, storedAttrs) => {
                    graphicAttributes.x = storedAttrs.cx, graphicAttributes.y = storedAttrs.cy, this._coordinate.transpose ? (graphicAttributes.startAngle = storedAttrs.y, 
                    graphicAttributes.endAngle = storedAttrs.y1, graphicAttributes.innerRadius = storedAttrs.x, 
                    graphicAttributes.outerRadius = storedAttrs.x1) : (graphicAttributes.startAngle = storedAttrs.x, 
                    graphicAttributes.endAngle = storedAttrs.x1, graphicAttributes.innerRadius = storedAttrs.y, 
                    graphicAttributes.outerRadius = storedAttrs.y1);
                },
                storedAttrs: "sizeAttrs"
            } ]
        } : {};
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d, _e, _f;
        const markEncoder = this.convertSimpleMarkEncode(encode), scaleXId = this.getScaleId("x"), scaleYId = this.getScaleId("y"), xAccessor = (0, 
        vgrammar_util_1.field)(markEncoder.x.field), res = {
            x: (datum, el, params) => {
                const scale = params[scaleXId], bandWidth = scale.bandwidth();
                return scale.scale(xAccessor(datum)) + bandWidth / 4;
            },
            x1: (datum, el, params) => {
                const scale = params[scaleXId], bandWidth = scale.bandwidth();
                return scale.scale(xAccessor(datum)) + 3 * bandWidth / 4;
            }
        };
        if ((0, vutils_1.isArray)(null === (_a = markEncoder.y) || void 0 === _a ? void 0 : _a.field)) res.y = {
            field: markEncoder.y.field[0],
            scale: markEncoder.y.scale
        }, res.y1 = {
            field: markEncoder.y.field[1],
            scale: markEncoder.y.scale
        }; else {
            const yAccessor = (0, vgrammar_util_1.field)(markEncoder.y.field);
            res.y = (datum, el, params) => {
                const yVals = yAccessor(datum), scale = params[scaleYId];
                return (0, vutils_1.isArray)(yVals) ? scale.scale(yVals[0]) : scale.scale(yVals);
            }, res.y1 = (datum, el, params) => {
                const scale = params[scaleYId], yVals = yAccessor(datum);
                if ((0, vutils_1.isArray)(yVals) && yVals.length > 1) return scale.scale(yVals[1]);
                const domain = scale.domain(), min = (0, vutils_1.minInArray)(domain), max = (0, 
                vutils_1.maxInArray)(domain), baseValue = min > 0 ? min : max < 0 ? max : 0;
                return scale.scale(baseValue);
            };
        }
        return markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color || markEncoder.group ? res.fill = null !== (_b = markEncoder.color) && void 0 !== _b ? _b : markEncoder.group : res.fill = null !== (_d = null === (_c = this.spec.style) || void 0 === _c ? void 0 : _c.fill) && void 0 !== _d ? _d : null === (_e = this.getPalette()) || void 0 === _e ? void 0 : _e[0], 
        "polar" === (null === (_f = this._coordinate) || void 0 === _f ? void 0 : _f.type) && (res.cx = (datum, el, params) => params[this._coordinate.id].origin().x, 
        res.cy = (datum, el, params) => params[this._coordinate.id].origin().y), res;
    }
}

exports.Interval = Interval, Interval.type = enums_1.PlotMakType.interval;
//# sourceMappingURL=interval.js.map