import type { WordcloudShapeEncodeChannels, WithDefaultEncode, PlotWordcloudShapeEncodeSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, TransformSpec, LabelSpec, InteractionSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class WordcloudShapeSemanticMark extends SemanticMark<PlotWordcloudShapeEncodeSpec, WordcloudShapeEncodeChannels> {
    static readonly type = PlotMakType.wordcloudShape;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    setDefaultMarkTransform(): TransformSpec[];
    setMainMarkSpec(parsedMainSpec: any): {
        key: any;
    } | {
        key?: undefined;
    };
    protected setMainMarkEnterEncode(): any;
    parseScaleByEncode(channel: WordcloudShapeEncodeChannels, option: ValueOf<WithDefaultEncode<PlotWordcloudShapeEncodeSpec, WordcloudShapeEncodeChannels>, WordcloudShapeEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotWordcloudShapeEncodeSpec, WordcloudShapeEncodeChannels>): GenerateBaseEncodeSpec<PlotWordcloudShapeEncodeSpec>;
    protected parseLabelSpec(): {
        marks: LabelSpec[];
        interactions: InteractionSpec[];
    };
}
