import type { TreeEncodeChannels, WithDefaultEncode, PlotTreeEncodeSpec, SemanticLabelOption, MarkSpec, ChannelEncodeType, DataSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, TransformSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
import type { ITextAttribute } from '@visactor/vrender-core';
export declare class TreeSemanticMark extends SemanticMark<PlotTreeEncodeSpec, TreeEncodeChannels> {
    static readonly type = PlotMakType.tree;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    setDefaultDataTransform(): TransformSpec[];
    getDataIdOfLink(): string;
    setMultipleData(): DataSpec[];
    parseScaleByEncode(channel: TreeEncodeChannels, option: ValueOf<WithDefaultEncode<PlotTreeEncodeSpec, TreeEncodeChannels>, TreeEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotTreeEncodeSpec, TreeEncodeChannels>): GenerateBaseEncodeSpec<PlotTreeEncodeSpec>;
    protected setLabelTextGetter(channel: string, option: SemanticLabelOption | boolean): ChannelEncodeType<ITextAttribute['text']>;
    setMainMarkSpec(): {
        key: string;
    };
    setMultiMarksSpec(): MarkSpec[];
}
